summaryrefslogtreecommitdiffabout
Side-by-side diff
Diffstat (more/less context) (ignore whitespace changes)
-rw-r--r--delta.jscad56
1 files changed, 56 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad
index 5c63b41..dcf6fcc 100644
--- a/delta.jscad
+++ b/delta.jscad
@@ -575,192 +575,248 @@ function base_sides() {
});
}
function base_extrusions() {
var rv = union( base_sides().map(function(x){return union(x)}) );
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv;
}
function columns() {
return THREEWINDS.map(function(w) {
return (E2020.extrusion({l:CONFIG.column.h})
.translate([0,CD.base.column_r,CONFIG.foot.h])
.rotateZ(w).setColor(CONFIG.color.extrusion)
);
});
}
function column_extrusions() {
var rv = union( columns() );
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv;
}
function duet() {
var C = CONFIG.duet;
var pholes = new CSG.Properties();
var hx = C.hole_spacing.x/2;
var hy = C.hole_spacing.y/2;
var hh = { nw: [-1,1], ne: [1,1], se: [1,-1], sw: [-1,-1] };
var holes = [];
for(w in hh) {
var h = hh[w],_x=h[0]*hx,_y=h[1]*hy;
holes.push(CSG.cylinder({start:[_x,_y,-1],end:[_x,_y,C.pcb_size.z+1],radius:3/2}));
pholes['c_'+w] = new CSG.Connector([_x,_y,0],[0,0,1],[1,0,0]);
}
rv = CSG.cube({
corner1: [-C.pcb_size.x/2, -C.pcb_size.y/2, 0],
corner2: [ C.pcb_size.x/2, C.pcb_size.y/2, C.pcb_size.z]
}).subtract(holes).setColor(CONFIG.color.pcb).union(
CSG.cube({
corner1: [-C.pcb_size.x/2,-C.hole_spacing.y/2+3,C.pcb_size.z],
corner2: [ C.pcb_size.x/2, C.hole_spacing.y/2-3,C.h]
}).setColor(CONFIG.color.bulk)
);
rv.properties.holes = pholes;
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
rv.properties.vitamin = true;
return rv;
}
function foot() {
var F = CONFIG.foot;
var br = F.bolt.hd/2+F.margin;
var bh = F.zscalefactor*Math.sqrt(Math.pow(F.d/2,2)-Math.pow(br,2));
var th = F.h-bh;
var r = 2*F.d;
var rv = CSG.sphere({ // botom contorted sphere
center: [0,0,0], radius: F.d/2, resolution: r
}).scale([1,1,F.zscalefactor]).translate([0,0,bh]).union(CSG.cylinder({ // top hat
start: [0,0,bh], end: [0,0,F.h], radius: F.d/2, resolution: r
})).intersect(CSG.cylinder({ // cut off excess
start: [0,0,0], end: [0,0,F.h], radius: F.d
})).subtract([
CSG.cylinder({ // bolt hole
start: [0,0,-1], end: [0,0,F.h+1], radius: F.bolt.d/2+PRINT.slide_tolerance
}), CSG.cylinder({ // nut hole
start: [0,0,F.h-F.nut.h-PRINT.play_tolerance],
end: [0,0,F.h],
radius: F.nut.d/2+PRINT.slide_tolerance, resolution: 6
}), CSG.cylinder({ // bolthead/washer hole
start: [0,0,-1], end: [0,0,F.h-F.nut.h-PRINT.play_tolerance-F.shell],
radius: F.bolt.hd/2+PRINT.play_tolerance
})
]).union(CSG.cylinder({ // bridging patch
start: [0,0,F.h-F.nut.h-PRINT.play_tolerance-PRINT.layer_height],
end: [0,0,F.h-F.nut.h-PRINT.play_tolerance],
radius: F.nut.d/2
}));
rv.properties.c_column = new CSG.Connector([0,0,F.h],[0,0,1],[1,0,0]);
rv.properties.P = new CSG.Connector([0,0,F.h],[0,0,-1],[1,0,0]);
return rv.setColor(CONFIG.color.parts);
}
function foot_foot() {
// TODO: connect in the altogethernow?
var F = CONFIG.foot;
var rv = CSG.cylinder({
start: [0,0,0], end: [0,0,F.foot.ho],
radius: F.bolt.hd/2+F.margin
}).union(CSG.cylinder({
start: [0,0,0], end: [0,0,F.foot.ho+F.foot.hi],
radius: F.bolt.hd/2+PRINT.play_tolerance-PRINT.fit_tolerance
}));
rv.properties.c_foot = new CSG.Connector([0,0,F.foot.ho],[0,0,1],[1,0,0]);
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv.setColor(CONFIG.color.softparts);
}
+function duetholder() {
+ var DH = CONFIG.duetholder;
+ var DHD = CD.duetholder;
+ var hw = DH.bolt.head.d+2*DH.margin;
+ var s = DH.bolt.l-CONFIG.extrusion.slotdepth+PRINT.play_tolerance*2;
+ var lower = CONFIG.foot.h-2*DH.s;
+ var hl = DHD.distance-CONFIG.extrusion.w;
+ var rv = union([
+ CSG.cube({ // vertical
+ corner1: [-hw/2,s,CONFIG.extrusion.w],
+ corner2: [hw/2,0,-lower]
+ }),
+ CSG.cube({ // horizontal extrusion
+ corner1: [-hw/2,-CONFIG.extrusion.w,0],
+ corner2: [ hw/2,0,-s]
+ }),
+ CSG.cube({ // horizontal
+ corner1: [-hw/2,0,-lower],
+ corner2: [hw/2,hl,-lower+DH.s]
+ }),
+ CSG.cylinder({ // boltend of horizontal part
+ start: [0,hl,-lower], end: [0,hl,-lower+DH.s],
+ radius: hw/2
+ })
+ ]);
+ rv = rv.subtract([
+ CSG.cylinder({ // through vertical
+ start: [0,-1,CONFIG.extrusion.w/2], end: [0,s+1,CONFIG.extrusion.w/2],
+ radius: DH.bolt.d/2+PRINT.slide_tolerance
+ }),
+ CSG.cylinder({ // through horizontal to extrusion
+ start: [0,-CONFIG.extrusion.w/2,-s-1],
+ end: [0,-CONFIG.extrusion.w/2,1],
+ radius: DH.bolt.d/2+PRINT.slide_tolerance
+ }),
+ CSG.cube({ // cut off
+ corner1: [-hw/2-1,-2*s,0],
+ corner2: [hw/2+1,0,-2*s]
+ }).rotateX(45).translate([0,-CONFIG.extrusion.w,0]),
+ CSG.cylinder({ // duet bolt
+ start: [0,hl,-lower], end: [0,hl,-lower+DH.s],
+ radius: DH.bolt.d/2+PRINT.slide_tolerance
+ })
+ ]);
+ var cp = [0,hl,-lower+DH.s];
+ rv.properties.duet = new CSG.Properties();
+ rv.properties.duet.c_sw = new CSG.Connector(cp,[0,0,1],[1,0,0]);
+ rv.properties.duet.c_se = new CSG.Connector(cp,[0,0,1],[1,0,0]);
+ rv.properties.duet.c_ne = new CSG.Connector(cp,[0,0,1],[-Math.cos(Math.PI/3),-Math.sin(Math.PI/3),0]);
+ rv.properties.duet.c_nw = new CSG.Connector(cp,[0,0,1],[-Math.cos(Math.PI/3),Math.sin(Math.PI/3),0]);
+ rv.properties.c_h = new CSG.Connector([0,-CONFIG.extrusion.w/2,0],[0,0,1],[1,0,0]);
+ rv.properties.c_v = new CSG.Connector([0,0,CONFIG.extrusion.w/2],[0,-1,0],[0,0,1]);
+ rv.properties.P = new CSG.Connector([-hw/2,0,0],[1,0,0],[0,1,0]);
+ return rv.setColor(CONFIG.color.parts);
+}
+
function refaxes(o) {
if(!o) o = {};
var l = o.l||20, g = o.g||0.7;
return union([
CSG.roundedCylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]),
CSG.roundedCylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]),
CSG.roundedCylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g])
]);
}
function P(x) {
return x.connectTo(x.properties.P,new CSG.Connector([0,0,0],[0,0,1],[1,0,0]), false, 0);
}
var PARTS = {
wip: function(params) {
return foot();
return union(base_extrusions(),column_extrusions(),duet());
alltogethernow: function(params) {
var cols = columns();
var sides = base_sides();
var feet = THREEWINDS.map(function(w,i) {
var rv = foot();
rv = rv.connectTo(rv.properties.c_column,cols[i].properties.c_bottom,false,0);
return rv;
});
var rv = union(cols).union(sides.map(union)).union(feet);
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv;
}
};
function main(params) {
var part = params.part && PARTS[params.part];
if(!part) return refaxes();
var rv = P(part(params));
if(!params.print) rv = rv.union(refaxes());
return rv;
}
function _main(params) {
var e = EFFECTOR.effector();
var hs = E3DV6.heatsink();
hs = hs.connectTo(hs.properties.grove_connector,e.properties.grove_connector,false,0);
var ms = microswitch();
var hd = EFFECTOR.hinged({
microswitch:ms,effector:e
});
ms = ms.connectTo(
ms.properties.screw_connector[0],
hd.properties.microswitch_screw_connector[0],
false, 0);
var hdhd = EFFECTOR.split_hinged(hd);
var fh = EFFECTOR.fanholder();
return union({
platform: e,
hinged: hdhd[1],
clamp: hdhd[0],
fanholder: fh,
alltogethernow: [e,hdhd[0],hdhd[1], columns(),hs,ms,fh]
}[params.part||'alltogethernow'])
var rv = union(
e,
hs,
columns(),
///hd,
hdhd[0], hdhd[1],
ms);
return rv;
}
function getParameterDefinitions() {
return [{
name: 'part',
type: 'choice',
values: [
'platform',
'hinged',
'clamp',
'fanholder',
'alltogethernow',
'wip'
],
captions: [
'Effector platform',
'Hinged part',
'Clamp',
'Fan holder',
'All together now!',
'Work in progress'
],
caption: 'Part',
initial: 'wip'
},{
name: 'print',
type: 'checkbox',